/* usage - functions that display helpful usage info text go here. -jk)*/

#include "common.h"
#include "jksql.h"
#include "hgTables.h"

static char const rcsid[] = "$Id: usage.c,v 1.5 2004/09/13 23:57:23 donnak Exp $";

void printMainHelp()
/* Put up main page help info. */
{
hPrintf("%s",
"    <P>This section provides a brief summary of the Table Browser control \n"
"    functionality. For more detailed information on using the Table Browser, \n"
"    see the User's Guide.\n"
"        <UL>\n"
"        <LI><B>genome: </B>Specifies which organism data to use.</LI>\n"
"        \n"
"        <LI><B>assembly: </B>Specifies which version of the organism's genome\n"
"        sequence to use.</LI>\n"
"        \n"
"        <LI><B>group: </B>Selects the type of tracks to be displayed in \n"
"        the <em>track</em> list. The options correspond to the track groupings\n"
"        shown in the Genome Browser.</LI>\n"
"        \n"
"        <LI><B>track: </B>Selects the annotation track data to work with. This \n"
"        list displays all tracks belonging to the group specified in the \n"
"        <em>group</em> list. </LI>\n"
"        \n"
"        <LI><B>table: </B>Selects the SQL table data to use. This list shows \n"
"        all tables associated with the track specified in the <em>track</em> \n"
"        list.</LI>\n"
"        \n"
"        <LI><B>region: </B>Restricts the query to a\n"
"        particular chromosome or region. Select <em>genome</em> to apply the \n"
"        query to the entire genome or <em>ENCODE</em> to examine only the \n"
"        ENCODE regions. \n"
"        To limit the query to a specific position range, type a \n"
"        chromosome name, e.g. <em>chrX</em>, or a chromosome coordinate \n"
"        range, such as chrX:100000-200000, in the text box.</LI>\n"
"        \n"
"        <LI><B>identifiers</B> (selected tracks only)<B>: </B>Restricts the \n"
"        output to table data that match a list of identifiers, for\n"
"        instance RefSeq accessions for the RefSeq track. If no identifiers \n"
"        are entered, all table data within the specified region will be \n"
"        displayed.</LI>\n"
"        \n"
"        <LI><B>filter: </B>Restricts the query to only those items that\n"
"        match certain criteria, e.g. genes with a single exon. Click the \n"
"        <em>Create</em> button to add a filter, the <em>Edit</em> button to \n"
"        modify an existing filter, or the <em>Clear</em> button to remove an \n"
"        existing filter.</LI>\n"
"        \n"
"        <LI><B>intersection: </B>Combines the output of two queries into a \n"
"        single set of data based on specific join criteria. For example, this \n"
"        can be used to find all SNPs that intersect with RefSeq coding \n"
"        regions. The intersection can be configured to retain the \n"
"        existing alignment structure of the table with a specified amount of \n" 
"        overlap, or discard the structure in favor of a simple list of position\n"
"        ranges using a base-pair intersection or union of the two data sets. \n"
"        The button functionalities are similar to those of the <em>filter</em>\n"
"        option.</LI> \n"
"        <LI><B>output: </B>Specifies the output format (not all options are \n"
"        available for some tracks). Formats include:\n"
"        <UL>\n"
"        <LI><em>Primary Table</em> - data from the primary table associated \n"
"        with the selected track, displayed in a tab-separated format suitable \n"
"        for import into spreadsheets and relational databases. The ASCII \n"
"        format may be read in any text browser.\n"
"        <LI><em>Sequence</em> - DNA (or protein sequence, in some cases) \n"
"        associated with the table.</LI>\n"
"        <LI>Selected Fields</em> - user-selected set of tab-separated fields \n"
"        from the table. \n"
"        <LI><em>Schema</em> - description of SQL schema of tables associated \n"
"        with track, but not the actual data in the tables.\n"
"        <LI><em>Statistics</em> - summary information about the data, such as\n"
"        the number of items and how many bases are coverd by the results of\n"
"        a query.</LI>\n"
"        <LI><em>BED</em> - positions of data items in a standard\n"
"        UCSC Browser format.</LI>\n"
"        \n"
"        <LI><em>GTF</em> - positions of all data items in a standard\n"
"        gene prediction format. (Both BED and GTF formats can be\n"
"        used as the basis for custom tracks).</LI>\n"
"        \n"
"        <LI><em>Custom Track</em> -  customized Genome Browser annotation  \n"
"        track based on the results of the query.</LI>\n"
"        \n"
"        </UL>\n"
"        </LI>\n"
"        \n"
"        <LI><B>Get Output: </B>Submits a data query based on the specified \n"
"        parameters and returns the output.</LI>\n"
"        \n"
"        <LI><B>Summary/Statistics: </B>Displays statistics about the data \n"
"        specified by the parameters.</LI>\n"
"        \n"
"        <LI><B>Describe Table Schema: </B>Displays schema information for the \n"
"        tables associated with the selected track.</LI>\n"
"        \n"
"        </UL>\n");
}
