/* codeBlast.h was originally generated by the autoSql program, which also 
 * generated codeBlast.c and codeBlast.sql.  This header links the database and
 * the RAM representation of objects. */

#ifndef CODEBLAST_H
#define CODEBLAST_H

#ifndef JKSQL_H
#include "jksql.h"
#endif

#define CODEBLAST_NUM_COLS 8

struct codeBlast
/* Table storing the codes and positional info for blast runs. */
    {
    struct codeBlast *next;  /* Next in singly linked list. */
    short bin;	/* Bin number for browser speedup */
    char *chrom;	/* Chromosome or FPC contig */
    unsigned chromStart;	/* Start position in chromosome */
    unsigned chromEnd;	/* End position in chromosome */
    char *name;	/* Name of item */
    unsigned score;	/* Score (0-1000) */
    char strand[2];	/* Strand */
    char *code;	/* BLAST code */
    };

void codeBlastStaticLoad(char **row, struct codeBlast *ret);
/* Load a row from codeBlast table into ret.  The contents of ret will
 * be replaced at the next call to this function. */

struct codeBlast *codeBlastLoad(char **row);
/* Load a codeBlast from row fetched with select * from codeBlast
 * from database.  Dispose of this with codeBlastFree(). */

struct codeBlast *codeBlastLoadAll(char *fileName);
/* Load all codeBlast from whitespace-separated file.
 * Dispose of this with codeBlastFreeList(). */

struct codeBlast *codeBlastLoadAllByChar(char *fileName, char chopper);
/* Load all codeBlast from chopper separated file.
 * Dispose of this with codeBlastFreeList(). */

#define codeBlastLoadAllByTab(a) codeBlastLoadAllByChar(a, '\t');
/* Load all codeBlast from tab separated file.
 * Dispose of this with codeBlastFreeList(). */

struct codeBlast *codeBlastLoadByQuery(struct sqlConnection *conn, char *query);
/* Load all codeBlast from table that satisfy the query given.  
 * Where query is of the form 'select * from example where something=something'
 * or 'select example.* from example, anotherTable where example.something = 
 * anotherTable.something'.
 * Dispose of this with codeBlastFreeList(). */

void codeBlastSaveToDb(struct sqlConnection *conn, struct codeBlast *el, char *tableName, int updateSize);
/* Save codeBlast as a row to the table specified by tableName. 
 * As blob fields may be arbitrary size updateSize specifies the approx size
 * of a string that would contain the entire query. Arrays of native types are
 * converted to comma separated strings and loaded as such, User defined types are
 * inserted as NULL. Note that strings must be escaped to allow insertion into the database.
 * For example "autosql's features include" --> "autosql\'s features include" 
 * If worried about this use codeBlastSaveToDbEscaped() */

void codeBlastSaveToDbEscaped(struct sqlConnection *conn, struct codeBlast *el, char *tableName, int updateSize);
/* Save codeBlast as a row to the table specified by tableName. 
 * As blob fields may be arbitrary size updateSize specifies the approx size.
 * of a string that would contain the entire query. Automatically 
 * escapes all simple strings (not arrays of string) but may be slower than codeBlastSaveToDb().
 * For example automatically copies and converts: 
 * "autosql's features include" --> "autosql\'s features include" 
 * before inserting into database. */ 

struct codeBlast *codeBlastCommaIn(char **pS, struct codeBlast *ret);
/* Create a codeBlast out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new codeBlast */

void codeBlastFree(struct codeBlast **pEl);
/* Free a single dynamically allocated codeBlast such as created
 * with codeBlastLoad(). */

void codeBlastFreeList(struct codeBlast **pList);
/* Free a list of dynamically allocated codeBlast's */

void codeBlastOutput(struct codeBlast *el, FILE *f, char sep, char lastSep);
/* Print out codeBlast.  Separate fields with sep. Follow last field with lastSep. */

#define codeBlastTabOut(el,f) codeBlastOutput(el,f,'\t','\n');
/* Print out codeBlast as a line in a tab-separated file. */

#define codeBlastCommaOut(el,f) codeBlastOutput(el,f,',',',');
/* Print out codeBlast as a comma separated list including final comma. */

/* -------------------------------- End autoSql Generated Code -------------------------------- */

#endif /* CODEBLAST_H */

