/* bacCloneXRef.c was originally generated by the autoSql program, which also 
 * generated bacCloneXRef.h and bacCloneXRef.sql.  This module links the database and
 * the RAM representation of objects. */

#include "common.h"
#include "linefile.h"
#include "dystring.h"
#include "jksql.h"
#include "bacCloneXRef.h"

static char const rcsid[] = "$Id: bacCloneXRef.c,v 1.1 2004/07/26 21:14:19 hartera Exp $";

void bacCloneXRefStaticLoad(char **row, struct bacCloneXRef *ret)
/* Load a row from bacCloneXRef table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
{
int sizeOne,i;
char *s;

ret->extName = row[0];
ret->intName = row[1];
ret->acc = row[2];
}

struct bacCloneXRef *bacCloneXRefLoad(char **row)
/* Load a bacCloneXRef from row fetched with select * from bacCloneXRef
 * from database.  Dispose of this with bacCloneXRefFree(). */
{
struct bacCloneXRef *ret;
int sizeOne,i;
char *s;

AllocVar(ret);
ret->extName = cloneString(row[0]);
ret->intName = cloneString(row[1]);
ret->acc = cloneString(row[2]);
return ret;
}

struct bacCloneXRef *bacCloneXRefLoadAll(char *fileName) 
/* Load all bacCloneXRef from a whitespace-separated file.
 * Dispose of this with bacCloneXRefFreeList(). */
{
struct bacCloneXRef *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[3];

while (lineFileRow(lf, row))
    {
    el = bacCloneXRefLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct bacCloneXRef *bacCloneXRefLoadAllByChar(char *fileName, char chopper) 
/* Load all bacCloneXRef from a chopper separated file.
 * Dispose of this with bacCloneXRefFreeList(). */
{
struct bacCloneXRef *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[3];

while (lineFileNextCharRow(lf, chopper, row, ArraySize(row)))
    {
    el = bacCloneXRefLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct bacCloneXRef *bacCloneXRefCommaIn(char **pS, struct bacCloneXRef *ret)
/* Create a bacCloneXRef out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new bacCloneXRef */
{
char *s = *pS;
int i;

if (ret == NULL)
    AllocVar(ret);
ret->extName = sqlStringComma(&s);
ret->intName = sqlStringComma(&s);
ret->acc = sqlStringComma(&s);
*pS = s;
return ret;
}

void bacCloneXRefFree(struct bacCloneXRef **pEl)
/* Free a single dynamically allocated bacCloneXRef such as created
 * with bacCloneXRefLoad(). */
{
struct bacCloneXRef *el;

if ((el = *pEl) == NULL) return;
freeMem(el->extName);
freeMem(el->intName);
freeMem(el->acc);
freez(pEl);
}

void bacCloneXRefFreeList(struct bacCloneXRef **pList)
/* Free a list of dynamically allocated bacCloneXRef's */
{
struct bacCloneXRef *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    bacCloneXRefFree(&el);
    }
*pList = NULL;
}

void bacCloneXRefOutput(struct bacCloneXRef *el, FILE *f, char sep, char lastSep) 
/* Print out bacCloneXRef.  Separate fields with sep. Follow last field with lastSep. */
{
int i;
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->extName);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->intName);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->acc);
if (sep == ',') fputc('"',f);
fputc(lastSep,f);
}

/* -------------------------------- End autoSql Generated Code -------------------------------- */

