/* loweTrnaGene.c was originally generated by the autoSql program, which also 
 * generated loweTrnaGene.h and loweTrnaGene.sql.  This module links the database and
 * the RAM representation of objects. */

#include "common.h"
#include "linefile.h"
#include "dystring.h"
#include "jksql.h"
#include "loweTrnaGene.h"

static char const rcsid[] = "$Id: loweTrnaGene.c,v 1.1 2004/01/15 21:31:41 aamp Exp $";

void loweTrnaGeneStaticLoad(char **row, struct loweTrnaGene *ret)
/* Load a row from loweTrnaGene table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
{
int sizeOne,i;
char *s;

ret->chrom = row[0];
ret->chromStart = sqlUnsigned(row[1]);
ret->chromEnd = sqlUnsigned(row[2]);
ret->name = row[3];
ret->score = sqlUnsigned(row[4]);
strcpy(ret->strand, row[5]);
ret->aa = row[6];
ret->ac = row[7];
strcpy(ret->ci, row[8]);
ret->scan = atof(row[9]);
}

struct loweTrnaGene *loweTrnaGeneLoad(char **row)
/* Load a loweTrnaGene from row fetched with select * from loweTrnaGene
 * from database.  Dispose of this with loweTrnaGeneFree(). */
{
struct loweTrnaGene *ret;
int sizeOne,i;
char *s;

AllocVar(ret);
ret->chrom = cloneString(row[0]);
ret->chromStart = sqlUnsigned(row[1]);
ret->chromEnd = sqlUnsigned(row[2]);
ret->name = cloneString(row[3]);
ret->score = sqlUnsigned(row[4]);
strcpy(ret->strand, row[5]);
ret->aa = cloneString(row[6]);
ret->ac = cloneString(row[7]);
strcpy(ret->ci, row[8]);
ret->scan = atof(row[9]);
return ret;
}

struct loweTrnaGene *loweTrnaGeneLoadAll(char *fileName) 
/* Load all loweTrnaGene from a whitespace-separated file.
 * Dispose of this with loweTrnaGeneFreeList(). */
{
struct loweTrnaGene *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[10];

while (lineFileRow(lf, row))
    {
    el = loweTrnaGeneLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct loweTrnaGene *loweTrnaGeneLoadAllByChar(char *fileName, char chopper) 
/* Load all loweTrnaGene from a chopper separated file.
 * Dispose of this with loweTrnaGeneFreeList(). */
{
struct loweTrnaGene *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[10];

while (lineFileNextCharRow(lf, chopper, row, ArraySize(row)))
    {
    el = loweTrnaGeneLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

struct loweTrnaGene *loweTrnaGeneLoadByQuery(struct sqlConnection *conn, char *query)
/* Load all loweTrnaGene from table that satisfy the query given.  
 * Where query is of the form 'select * from example where something=something'
 * or 'select example.* from example, anotherTable where example.something = 
 * anotherTable.something'.
 * Dispose of this with loweTrnaGeneFreeList(). */
{
struct loweTrnaGene *list = NULL, *el;
struct sqlResult *sr;
char **row;

sr = sqlGetResult(conn, query);
while ((row = sqlNextRow(sr)) != NULL)
    {
    el = loweTrnaGeneLoad(row);
    slAddHead(&list, el);
    }
slReverse(&list);
sqlFreeResult(&sr);
return list;
}

void loweTrnaGeneSaveToDb(struct sqlConnection *conn, struct loweTrnaGene *el, char *tableName, int updateSize)
/* Save loweTrnaGene as a row to the table specified by tableName. 
 * As blob fields may be arbitrary size updateSize specifies the approx size
 * of a string that would contain the entire query. Arrays of native types are
 * converted to comma separated strings and loaded as such, User defined types are
 * inserted as NULL. Note that strings must be escaped to allow insertion into the database.
 * For example "autosql's features include" --> "autosql\'s features include" 
 * If worried about this use loweTrnaGeneSaveToDbEscaped() */
{
struct dyString *update = newDyString(updateSize);
dyStringPrintf(update, "insert into %s values ( '%s',%u,%u,'%s',%u,'%s','%s','%s','%s',%f)", 
	tableName,  el->chrom,  el->chromStart,  el->chromEnd,  el->name,  el->score,  el->strand,  el->aa,  el->ac,  el->ci,  el->scan);
sqlUpdate(conn, update->string);
freeDyString(&update);
}

void loweTrnaGeneSaveToDbEscaped(struct sqlConnection *conn, struct loweTrnaGene *el, char *tableName, int updateSize)
/* Save loweTrnaGene as a row to the table specified by tableName. 
 * As blob fields may be arbitrary size updateSize specifies the approx size.
 * of a string that would contain the entire query. Automatically 
 * escapes all simple strings (not arrays of string) but may be slower than loweTrnaGeneSaveToDb().
 * For example automatically copies and converts: 
 * "autosql's features include" --> "autosql\'s features include" 
 * before inserting into database. */ 
{
struct dyString *update = newDyString(updateSize);
char  *chrom, *name, *strand, *aa, *ac, *ci;
chrom = sqlEscapeString(el->chrom);
name = sqlEscapeString(el->name);
strand = sqlEscapeString(el->strand);
aa = sqlEscapeString(el->aa);
ac = sqlEscapeString(el->ac);
ci = sqlEscapeString(el->ci);

dyStringPrintf(update, "insert into %s values ( '%s',%u,%u,'%s',%u,'%s','%s','%s','%s',%f)", 
	tableName,  chrom, el->chromStart , el->chromEnd ,  name, el->score ,  strand,  aa,  ac,  ci, el->scan );
sqlUpdate(conn, update->string);
freeDyString(&update);
freez(&chrom);
freez(&name);
freez(&strand);
freez(&aa);
freez(&ac);
freez(&ci);
}

struct loweTrnaGene *loweTrnaGeneCommaIn(char **pS, struct loweTrnaGene *ret)
/* Create a loweTrnaGene out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new loweTrnaGene */
{
char *s = *pS;
int i;

if (ret == NULL)
    AllocVar(ret);
ret->chrom = sqlStringComma(&s);
ret->chromStart = sqlUnsignedComma(&s);
ret->chromEnd = sqlUnsignedComma(&s);
ret->name = sqlStringComma(&s);
ret->score = sqlUnsignedComma(&s);
sqlFixedStringComma(&s, ret->strand, sizeof(ret->strand));
ret->aa = sqlStringComma(&s);
ret->ac = sqlStringComma(&s);
sqlFixedStringComma(&s, ret->ci, sizeof(ret->ci));
ret->scan = sqlFloatComma(&s);
*pS = s;
return ret;
}

void loweTrnaGeneFree(struct loweTrnaGene **pEl)
/* Free a single dynamically allocated loweTrnaGene such as created
 * with loweTrnaGeneLoad(). */
{
struct loweTrnaGene *el;

if ((el = *pEl) == NULL) return;
freeMem(el->chrom);
freeMem(el->name);
freeMem(el->aa);
freeMem(el->ac);
freez(pEl);
}

void loweTrnaGeneFreeList(struct loweTrnaGene **pList)
/* Free a list of dynamically allocated loweTrnaGene's */
{
struct loweTrnaGene *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    loweTrnaGeneFree(&el);
    }
*pList = NULL;
}

void loweTrnaGeneOutput(struct loweTrnaGene *el, FILE *f, char sep, char lastSep) 
/* Print out loweTrnaGene.  Separate fields with sep. Follow last field with lastSep. */
{
int i;
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->chrom);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->chromStart);
fputc(sep,f);
fprintf(f, "%u", el->chromEnd);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->name);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->score);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->strand);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->aa);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->ac);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->ci);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%f", el->scan);
fputc(lastSep,f);
}

/* -------------------------------- End autoSql Generated Code -------------------------------- */

